var numerotation = function (id,number){
    if(!number){number=id;}
      if($("#"+id).length>0)
      {
        var canvas = $("#"+id).data().snapshot._extra_canvas;
          
        var ctx= canvas.getContext('2d');
        vignHeight=canvas.height/4;
        fontHeight=vignHeight-30;
        vignWidthi=Math.round(vignHeight*0.55); 

        if(number>999) { vignWidth=vignWidthi*4;}
        else if(number>99) { vignWidth=vignWidthi*3;}
        else if(number>9) { vignWidth=vignWidthi*2;}
        else vignWidth=vignWidthi;

        ctx.fillStyle="#5C78DC";

        ctx.fillRect(0,0,vignWidth+30,vignHeight);
        ctx.fillStyle="#FFFFFF";
        ctx.font = "bold "+vignHeight+"px Courier New";
        ctx.fillText(number,10,vignHeight-20);
      }
}

function drag(event) {
    event.dataTransfer.setData("text", event.target.id);
}

function allowDrop(event) {
    event.preventDefault();
    destId = event.target.id;
    nodes=document.getElementById("snapshots").childNodes;
    for(var i=0; i<nodes.length; i++) {
        if (nodes[i].nodeName.toLowerCase() == 'canvas') {
             nodes[i].style.borderLeft='0';
         }
    }
    document.getElementById("show_stream").style.borderLeft='0';
    document.getElementById(destId).style.borderLeft="3px  solid #8fb2bf";
}

function move(event) {
    event.preventDefault();
    var oldId = event.dataTransfer.getData("text");

        snapshots=document.getElementById('snapshots');

        oldPicture=document.getElementById(oldId);
        newPicture=document.getElementById(event.target.id);

        snapshots.insertBefore(oldPicture,newPicture);

        if(oldId!="show_stream") 
        {
            destinationId=event.target.id;
            newId=destinationId-1;

            document.getElementById(destinationId).style.borderLeft="0";

            if(destinationId<oldId) first=destinationId;
            else first=oldId;

            nodes=document.getElementById("snapshots").childNodes;
            frameNumber=parseInt(document.getElementById("frameNumber").innerHTML);

            i=parseInt(first)-1;
            j=parseInt(first);
            
            while(i<frameNumber)
            {
                if(nodes[i].id!="show_stream")
                {
                    nodes[i].id=j;
                    numerotation(j);
                    j++;
                }
                i++;
            }
        }
    
        for(var i=0; i<nodes.length; i++) {
            if (nodes[i].nodeName.toLowerCase() == 'canvas') {
                 nodes[i].style.borderLeft='0';
             }
        }
}

var allowDrop = function (event) {
    event.preventDefault();
}
     
var recognitionStart = function() {
    window.SpeechRecognition = window.SpeechRecognition ||  window.webkitSpeechRecognition;

    recognition = new SpeechRecognition();
    recognition.continuous = true;
    recognition.interimResults = true;
    lang=$("#lang").val();
    if (lang=='fr') recognition.lang = 'fr-FR';
//        else recognition.lang = 'en-US';

        recognition.onresult = function(event) {

            if($("#optionRecognition").prop('checked'))
            {

            lang=$("#lang").val();
             if (lang=='fr') recognition.lang = 'fr-FR';

              var results = event.results;
              // results is an array of SpeechRecognitionResults
              // each of which is an array of SpeechRecognitionAlternatives
              // in this demo, we only use the first alternative
              var interimTranscript = '';
              for (var i = event.resultIndex; i !== results.length; ++i) {
                var result = results[i];
                // once speaking/recognition stops, a SpeechRecognitionEvent
                // is fired with a single result, for which isFinal is true
                if (result.isFinal) {
                  console.log('Final transcript: ' + results[0][0].transcript);
                    if($("video:first").length>0)
                    {
                        if(results[0][0].transcript.match(/photo/))
                            {
                                take_snapshots(1);
                            }
                        if(results[0][0].transcript.match(/(supprimer|delete)/))
                            {
                                discard_snapshot();
                            }
                        if(results[0][0].transcript.match(/(merci|thanks|thank you)/))
                            {
                                u = new SpeechSynthesisUtterance();
                                if($("#lang").val()=='fr')
                                {
                                    u.lang = 'fr-FR';
                                    u.text = 'De rien.';
                                }
                                else{
                                    u.lang = 'en-EN';
                                    u.text = 'You\'re welcome.';
                                }
                                speechSynthesis.speak(u);
                            }
                        if(results[0][0].transcript.match(/(arrière|avant|suivant|précédent|previous|next)/))
                            {
                                currentFrame=$('.selected:first').attr('id');
                                frameNumber=parseInt($('#frameNumber').text());
                                if(currentFrame==undefined) currentFrame=frameNumber+1;
                                currentFrame=parseInt(currentFrame);
                                if (results[0][0].transcript.match(/(arrière|précédent|previous)/)) nextFrame=currentFrame-1;
                                if (results[0][0].transcript.match(/(avant|suivant|next)/)) nextFrame=currentFrame+1;
                                select_snapshot(nextFrame);
                            }
                    }
                  recognition.stop();
                } else {
                  interimTranscript += result[0].transcript;
                  console.log('Interim transcript: ' + interimTranscript);
                }
              }
            }

        };
    recognition.onend = function() {
      recognition.start();
    };

    recognition.onerror = function(event) {
      console.log('Error: ' + event.error);
    };
    recognition.start();
}